unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, clipbrd, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    grid1: TStringGrid;
    mnuMeta1: TMenuItem;
    Image1: TImage;
    Font1: TMenuItem;
    Color1: TMenuItem;
    ColorDialog: TColorDialog;
    FontDialog: TFontDialog;
    Option1: TMenuItem;
    Gridlines1: TMenuItem;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    C1: TMenuItem;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    VerLines1: TMenuItem;
    HorLines1: TMenuItem;
    SolidPen1: TMenuItem;
    Loadgrid: TMenuItem;
    OpenDialog: TOpenDialog;
    FromFile1: TMenuItem;
    FromClipbord1: TMenuItem;
    Button1: TButton;
    GridCol1: TMenuItem;
    Fixedcells1: TMenuItem;
    procedure mnuMeta1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure Gridlines1Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure Edit5KeyPress(Sender: TObject; var Key: Char);
    procedure VerLines1Click(Sender: TObject);
    procedure HorLines1Click(Sender: TObject);
    procedure SolidPen1Click(Sender: TObject);
    procedure FromFile1Click(Sender: TObject);
    procedure FromClipbord1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure GridCol1Click(Sender: TObject);
    procedure Fixedcells1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure StringGrid2EMF(grid : Tstringgrid; Horlines,Verlines : boolean; filename : string);
var i,j,w,h,h1,w1 : integer; m : tmetafile;  c: tmetafilecanvas;  r : trect;
begin m:=tmetafile.Create;w:=0; h:=0;
  with grid do for i:=0 to colcount-1 do w:=w+ColWidths[i]+gridlinewidth;
  with grid do for i:=0 to rowcount-1 do h:=h+RowHeights[i]+gridlinewidth;
  m.Width:=w; m.Height:=h;
  c:=tmetafilecanvas.Create(m,0); c.Font:=grid.Font;
  c.Brush.Color:=grid.Color; c.Brush.Style:=bssolid;
  c.FillRect(rect(0,0,m.width,m.height));
  with grid do
  for i:=0 to colcount-1 do
  for j:=0 to rowcount-1 do
  begin r:=grid.CellRect(i,j);
        if (i=0)or(j=0) then
        c.Brush.Color:=grid.FixedColor
         else
         c.Brush.Color:=grid.Color;
         c.FillRect(r);
        c.TextOut(r.left+3,r.top+1,cells[i,j])
  end;
  c.pen.Color:=$b0b0b0;
  w1:=0; h1:=0;
  with grid do
  begin c.MoveTo(0,0); c.LineTo(w,0); //first hor line
     for i:=0 to rowcount-1 do
     if HorLines then
     begin h1:=h1+RowHeights[i]+gridlinewidth;
         c.MoveTo(0,h1);
         c.LineTo(w,h1);
     end;
     c.MoveTo(0,h); c.LineTo(w,h); //do last hor line
     c.MoveTo(0,0); c.LineTo(0,h); //first ver line
     if VerLines then
     for i:=0 to colcount do
     begin w1:=w1+colwidths[i]+gridlinewidth;
           c.MoveTo(w1,0);
           c.LineTo(w1,h);
     end;
     c.MoveTo(w,0); c.LineTo(w,h) //last ver line
  end;
  c.Free; clipboard.Assign(m);  m.SaveToFile(filename);
  m.free;
  showmessage('Meta file saved and put in clipboard')
end;

procedure TForm1.mnuMeta1Click(Sender: TObject);
var i,j,w,h,h1,w1 : integer; m : tmetafile;  c: tmetafilecanvas;  r : trect;
begin m:=tmetafile.Create;w:=0; h:=0;
  with grid1 do for i:=0 to colcount-1 do w:=w+ColWidths[i]+gridlinewidth;
  with grid1 do for i:=0 to rowcount-1 do h:=h+RowHeights[i]+gridlinewidth;
  m.Width:=w; m.Height:=h;
  c:=tmetafilecanvas.Create(m,0); c.Font:=grid1.Font;
  c.Brush.Color:=grid1.Color; c.Brush.Style:=bssolid;
  c.FillRect(rect(0,0,m.width,m.height));
  with grid1 do
  for i:=0 to colcount-1 do
  for j:=0 to rowcount-1 do
  begin r:=grid1.CellRect(i,j);
//      c.TextRect(r,1,1,cells[i,j]);
        if (i=0)or(j=0) then
        c.Brush.Color:=grid1.FixedColor //$b0b0b0 //clgray;
         else
         c.Brush.Color:=grid1.Color;
         c.FillRect(r);
        c.TextOut(r.left+3,r.top+1,cells[i,j])
  end;
  c.pen.Color:=$b0b0b0;  //c.pen.Color:=clblack;
  if solidpen1.Checked then c.Pen.Style:=psSolid else c.Pen.Style:=psDot;
  w1:=0; h1:=0;
  if  gridlines1.Checked then with grid1 do
  begin c.MoveTo(0,0); c.LineTo(w,0); //first ho line
     for i:=0 to rowcount-1 do
     if HorLines1.Checked then
     begin h1:=h1+RowHeights[i]+gridlinewidth;
         c.MoveTo(0,h1);
         c.LineTo(w,h1);
     end;
     c.MoveTo(0,h); c.LineTo(w,h); //do last hor line
     c.MoveTo(0,0); c.LineTo(0,h); //first ver line
     if VerLines1.Checked then
     for i:=0 to colcount do
     begin w1:=w1+colwidths[i]+gridlinewidth;
           c.MoveTo(w1,0);
           c.LineTo(w1,h);
     end;
     c.MoveTo(w,0); c.LineTo(w,h) //last ver line
  end;
  c.Free; clipboard.Assign(m); image1.Picture.Metafile.Assign(m);// m.SaveToFile('temp1.emf');
  m.free;
  showmessage('Meta file in clipboard')
end;

procedure TForm1.FormCreate(Sender: TObject);
var i,j : integer;
begin randomize;
  with grid1 do
  for i:=0 to colcount-1 do for j:=0 to rowcount-1 do cells[i,j]:=inttostr(random(10000))

end;

procedure TForm1.Font1Click(Sender: TObject);
begin
 if fontdialog.Execute=false then exit;
 grid1.Font:=fontdialog.Font
end;

procedure TForm1.Gridlines1Click(Sender: TObject);
begin
 gridlines1.Checked:=not( gridlines1.Checked);
 if gridlines1.Checked then grid1.GridLineWidth:=1 else grid1.GridLineWidth:=0
end;

procedure TForm1.C1Click(Sender: TObject);
var i : integer;
begin
  with grid1 do for i:=0 to colcount-1 do cols[i].Clear

end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var i : integer;
begin if key=#13 then else exit;
 i:=strtointdef(edit1.text,0);
 if i=0 then exit else grid1.RowCount:=i
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
var i : integer;
begin if key=#13 then else exit;
 i:=strtointdef(edit2.text,0);
 if i=0 then exit else grid1.colCount:=i
end;

procedure TForm1.Edit4KeyPress(Sender: TObject; var Key: Char);
var i : integer;
begin if key=#13 then
      begin
      i:=strtointdef(edit4.text,0);
      if i<3 then exit;
      grid1.DefaultRowHeight:=i
      end
end;

procedure TForm1.Edit5KeyPress(Sender: TObject; var Key: Char);
var i : integer;
begin if key=#13 then
      begin
      i:=strtointdef(edit5.text,0);
      if i<3 then exit;
      grid1.DefaultColWidth:=i
      end
end;

procedure TForm1.VerLines1Click(Sender: TObject);
begin
 VerLines1.Checked:=not(VerLines1.Checked)
end;

procedure TForm1.HorLines1Click(Sender: TObject);
begin
 horlines1.Checked:=not(horlines1.Checked)
end;

procedure TForm1.SolidPen1Click(Sender: TObject);
begin
 solidpen1.Checked:=not(solidpen1.Checked)
end;

procedure TForm1.FromFile1Click(Sender: TObject);
var i,j,k,tot : integer;  st : tstringlist;
begin if opendialog.Execute=false then exit;
  tot:=strtointdef(edit3.text,0); if tot<1 then exit;
  st:=tstringlist.Create; st.Sorted:=false; st.Capacity:=tot;
  st.LoadFromFile(opendialog.filename);  k:=0; tot:=st.Count;
  with grid1 do
  for i:=0 to colcount do for j:=0 to rowcount-1 do
  begin cells[j,i]:=st.Strings[k]; inc(k);
        if (k>=tot)or(k>rowcount*colcount) then exit
  end;
  st.Free
end;

procedure TForm1.FromClipbord1Click(Sender: TObject);
var i,j,k,tot : integer;  st : tstringlist;
begin
   tot:=strtointdef(edit3.text,0); if tot<1 then exit;
   if clipboard.HasFormat(CF_TEXT)=false then exit;
   st:=tstringlist.Create; st.Sorted:=false; st.Capacity:=tot;
   st.Text:=clipboard.AsText;
  k:=0; tot:=st.Count;
  with grid1 do
  for i:=0 to colcount-1 do for j:=0 to rowcount-1 do
  begin cells[i,j]:=st.Strings[k]; inc(k);
        if (k>=tot)or(k>rowcount*colcount) then exit
  end;
  st.Free
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
// stringgrid2emf(grid1,true,true,'p:\e.emf');
end;

procedure TForm1.GridCol1Click(Sender: TObject);
begin
if colordialog.Execute=false then exit;
 grid1.Color:=colordialog.Color
end;

procedure TForm1.Fixedcells1Click(Sender: TObject);
begin
if colordialog.Execute=false then exit;
 grid1.FixedColor:=colordialog.Color
end;

end.
